package com.dsic.gj_erp.bean;

import org.springframework.beans.BeansException;
import org.springframework.context.ApplicationContext;
import org.springframework.context.ApplicationContextAware;
import org.springframework.context.ApplicationEvent;
import org.springframework.stereotype.Component;

@Component
public class SpringContextHolder implements ApplicationContextAware {

    private static ApplicationContext springContext;
    @Override
    public void setApplicationContext(ApplicationContext applicationContext) throws BeansException {
        SpringContextHolder.springContext = applicationContext;
    }

    /**
     * 返回spring上下文环境对象
     *
     * @return ApplicationContext
     */
    public static ApplicationContext getSpringContext() {
        return springContext;
    }


    /**
     * 按名称获取spring bean
     *
     */
    public static Object getBean(String name) {
        return springContext.getBean(name);
    }

    /**
     * 按类型获取spring bean
     *
     */
    public static <T> T getBean(Class<T> requiredType) {
        return springContext.getBean(requiredType);
    }



    /**
     * 发布事件到spring
     */
    public static void pushEvent(ApplicationEvent event) {
        springContext.publishEvent(event);
    }

    /**
     * 发布事件到spring
     */
    public static void pushEvent(Object event) {
        springContext.publishEvent(event);
    }
}